<script setup lang="ts">
import AppButton from '@/components/ui/AppButton.vue'
import DataTable, { type DataTableColumn } from '@/components/ui/DataTable.vue'
import { client, type ExpectedUserJoined } from '@/scripts/api-helper'
import { GlobalError, useAppStore } from '@/stores/app'
import { computed, onMounted, reactive, ref } from 'vue'

const columns: DataTableColumn[] = [
  { name: 'Sciper', field: 'sciper' },
  { name: 'Status', field: 'user', style: 'flex-center' },
  { name: 'Firstname', field: 'firstname' },
  { name: 'Lastname', field: 'lastname' },
  { name: 'Program', field: 'program', style: 'flex-center' },
  { name: 'Mail EPFL', field: 'mail_epfl' },
  { name: 'Mail Perso', field: 'mail_perso' }
]

type FilterPreset =
  | 'all'
  | 'form-incomplete'
  | 'form-invalid'
  | 'no-account'
  | 'no-account-or-empty'
  | 'invalid-pp'
  | 'form-valid'

const app = useAppStore()
const fileInput = ref<HTMLInputElement>()
const state = reactive({
  file: File,
  rows: [] as ExpectedUserJoined[],
  filterPreset: 'all' as FilterPreset,
  export: null as string | null,
  exportId: null as string | null
})

function uploadClicked() {
  if (fileInput.value != null) {
    const input = fileInput.value
    input.click()
  }
}

function onFileChanged($event: Event) {
  const target = $event.target as HTMLInputElement
  const file: File = target.files![0]
  file.text().then(async (text) => {
    const { error, data: expectedUsers } = await client.POST('/api/admin/expected-users', {
      body: {
        admin_key: app.adminKey!,
        csv_string: text
      }
    })
    if (error != null) {
      app.setGlobalError(GlobalError.ActionFailedError)
    } else {
      state.rows = expectedUsers
    }
  })
}

async function loadExpectedUsers() {
  const { error, data: expectedUsers } = await client.GET('/api/admin/expected-users', {
    params: {
      query: {
        admin_key: app.adminKey!
      }
    }
  })
  if (error != null) {
    app.setGlobalError(GlobalError.ActionFailedError)
  } else {
    state.rows = expectedUsers
  }
}

onMounted(() => {
  loadExpectedUsers()
})

const filteredRows = computed(() => {
  switch (state.filterPreset) {
    case 'all':
      return state.rows
    case 'form-incomplete':
      return state.rows.filter(
        (r) => r.user && r.user.profile_picture_status === 'Ready' && !r.user.form_validated
      )
    case 'form-invalid':
      return state.rows.filter((r) => r.user && !r.user.form_validated)
    case 'no-account':
      return state.rows.filter((r) => !r.user)
    case 'no-account-or-empty':
      return state.rows.filter((r) => !r.user || r.user.profile_picture_status === 'Empty')
    case 'invalid-pp':
      return state.rows.filter((r) => r.user && r.user.profile_picture_status !== 'Ready')
    case 'form-valid':
      return state.rows.filter((r) => r.user && r.user.form_validated)

    default:
      throw 'invalid export type'
  }
})

// export as
//    email,name,attributes
//    user1@mail.com,"User One","{""age"": 42, ""planet"": ""Mars""}"
function exportCSV() {
  const exportDate = new Date().toISOString()
  state.exportId = `${state.filterPreset}-${exportDate}`
  state.export =
    'email,name,attributes\n' +
    filteredRows.value
      .map((e) => {
        const attributes = `"{""yearbook-export"": ""${state.exportId}"", ""yearbook-program"": ""${e.program}""}"`
        let mail = e.mail_perso
        let mailSeparatorPos = mail.indexOf(';')
        if (mailSeparatorPos !== -1) {
          mail = mail.slice(0, mailSeparatorPos)
        }
        return `${mail},"${e.firstname} ${e.lastname}",${attributes}`
      })
      .join('\n')
}

function resetCSV() {
  state.export = null
}

function downloadCSV() {
  if (!state.export) {
    return
  }
  const filename = `yearbook-export-${state.exportId}.csv`
  const blob = new Blob([state.export], { type: 'text/csv' })
  const elem = window.document.createElement('a')
  elem.href = window.URL.createObjectURL(blob)
  elem.download = filename
  document.body.appendChild(elem)
  elem.click()
  document.body.removeChild(elem)
}
</script>

<template>
  <main id="main">
    <div class="flex justify-between">
      <h1 class="mb-5 text-2xl dark:text-white font-semibold">Expected users</h1>

      <RouterLink to="/admin/users">
        <AppButton>Switch to all users</AppButton>
      </RouterLink>
    </div>

    <div class="mb-5" v-if="!!state.export">
      <div class="mb-1 flex justify-between">
        <h3 class="mb-3 text-xl dark:text-white font-semibold">Export ({{ state.exportId }})</h3>
        <AppButton @click="downloadCSV">Download CSV</AppButton>
      </div>
      <textarea
        v-model="state.export"
        rows="4"
        class="block p-2.5 w-full text-sm text-gray-900 bg-gray-50 rounded-lg border border-gray-300 focus:ring-blue-500 focus:border-blue-500 dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500"
        readonly
      />
    </div>

    <DataTable :columns="columns" :rows="filteredRows" class="min-h-80">
      <template v-slot:toolbar>
        <div
          class="flex flex-col px-4 py-3 space-y-3 lg:flex-row lg:items-center lg:justify-between lg:space-y-0 lg:space-x-4"
        >
          <div class="flex items-center flex-1 space-x-4">
            <h5>
              <span class="text-gray-500">Total: </span>
              <span class="dark:text-white">{{ filteredRows.length }}</span>
            </h5>
          </div>

          <div
            class="flex flex-col flex-shrink-0 space-y-3 md:flex-row md:items-center lg:justify-end md:space-y-0 md:space-x-3"
          >
            <select
              v-model="state.filterPreset"
              @change="resetCSV"
              class="bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg border-s-gray-100 dark:border-s-gray-700 border-s-2 focus:ring-blue-500 focus:border-blue-500 block w-full p-2.5 dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500"
            >
              <option value="all" selected>All expected users</option>
              <option value="no-account">No account</option>
              <option value="no-account-or-empty">No account or Empty PP</option>
              <option value="invalid-pp">Registered & Invalid Profile Picture</option>
              <option value="form-invalid">Registered & Form invalid</option>
              <option value="form-incomplete">Registered, PP Ready & Form invalid</option>
              <option value="form-valid">Registered & Form valid</option>
            </select>

            <AppButton @click="() => exportCSV()">Export</AppButton>
            <input
              ref="fileInput"
              class="hidden"
              type="file"
              accept="text/csv"
              @change="onFileChanged"
            />

            <AppButton @click="uploadClicked">Upload</AppButton>
            <AppButton @click="loadExpectedUsers">Reload</AppButton>
          </div>
        </div>
      </template>

      <template v-slot:program="s">
        <span
          class="bg-blue-100 text-blue-800 text-xs font-medium me-2 px-2.5 py-0.5 rounded dark:bg-blue-900 dark:text-blue-300"
        >
          {{ s.row.program }}
        </span>
      </template>

      <template v-slot:user="s">
        <RouterLink
          v-if="s.row.user && s.row.user.form_validated"
          target="_blank"
          :to="`/admin/user/${s.row.sciper}`"
        >
          <span
            class="bg-green-100 text-green-800 text-xs font-medium me-2 px-2.5 py-0.5 rounded dark:bg-green-900 dark:text-green-300"
          >
            Form valid
          </span>
        </RouterLink>

        <RouterLink target="_blank" v-else-if="s.row.user" :to="`/admin/user/${s.row.sciper}`">
          <span
            class="bg-yellow-100 text-yellow-800 text-xs font-medium me-2 px-2.5 py-0.5 rounded dark:bg-yellow-900 dark:text-yellow-300"
          >
            PP: {{ s.row.user.profile_picture_status }}
          </span>
        </RouterLink>

        <RouterLink target="_blank" v-else :to="`/admin/register-user/${s.row.sciper}`">
          <span
            class="bg-red-100 text-red-800 text-xs font-medium me-2 px-2.5 py-0.5 rounded dark:bg-red-900 dark:text-red-300"
          >
            No account
          </span>
        </RouterLink>
      </template>
    </DataTable>
  </main>
</template>
